Option Strict Off
Option Explicit On

Imports System.Threading

Imports System.Text

Friend Class frmMain
    Inherits System.Windows.Forms.Form

    Dim giDeviceNumber As Integer

    Dim giSubdeviceNumber As Integer



    Private Sub cmdExit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdExit.Click

        Dim i_me_error As Integer

        i_me_error = meClose(0)

        Close()

    End Sub

    Private Sub cmdStart_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdStart.Click

        Dim i_me_error As Integer

        Dim d_frequency As Double

        ' Generate a sinus wave with amplitude 8.0 Volts, offset 0.0 Volts and frequency 1.0 Hz

        d_frequency = 1.0

        i_me_error = meIDSToolsWaveGen(giDeviceNumber, _
                                       giSubdeviceNumber, _
                                       ME_UNIT_VOLT, _
                                       MEIDS_TOOLS_WAVEGEN_SHAPE_SINUS, _
                                       8.0, _
                                       0.0, _
                                       d_frequency)

        If (i_me_error <> ME_ERRNO_SUCCESS) Then

            Exit Sub

        End If

        cmdStart.Enabled = False
        cmdExit.Enabled = False
        cmdStop.Enabled = True

    End Sub

    Private Sub cmdStop_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdStop.Click

        Dim i_me_error As Integer

        Dim stream_stop As meIOStreamStop_t

        stream_stop.iDevice = giDeviceNumber
        stream_stop.iSubdevice = giSubdeviceNumber
        stream_stop.iStopMode = ME_STOP_MODE_IMMEDIATE
        stream_stop.iFlags = ME_IO_STREAM_STOP_TYPE_NO_FLAGS
        stream_stop.iErrno = 0

        i_me_error = meIOStreamStop(stream_stop, _
               1, _
               ME_IO_STREAM_STOP_NO_FLAGS)

        If (i_me_error <> ME_ERRNO_SUCCESS) Then

            Exit Sub

        End If

        cmdStart.Enabled = True
        cmdExit.Enabled = True
        cmdStop.Enabled = False

    End Sub

    Private Sub frmMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load

        Dim i_me_error As Integer

        Dim i_number_of_devices As Integer

        Dim i_index_device As Integer

        Dim i_vendor_id As Integer
        Dim i_device_id As Integer
        Dim i_serial_no As Integer
        Dim i_bus_type As Integer
        Dim i_bus_no As Integer
        Dim i_dev_no As Integer
        Dim i_func_no As Integer
        Dim i_plugged As Integer

        giDeviceNumber = -1 ' Number of used board.

        giSubdeviceNumber = -1 ' Number of used device.

        ' Search for an AI-Streaming subdevice in the system

        meErrorSetDefaultProc(ME_SWITCH_ENABLE)

        ' Open the driver system

        i_me_error = meOpen(0)

        If (i_me_error <> ME_ERRNO_SUCCESS) Then
            Exit Sub
        End If

        ' Query the number of devices

        i_me_error = meQueryNumberDevices(i_number_of_devices)

        If (i_me_error <> ME_ERRNO_SUCCESS) Then
            Exit Sub
        End If

        If (i_number_of_devices = 0) Then

            MessageBox.Show("No ME-iDS Devices found in system")

            i_me_error = meClose(0)

            Close()

            Exit Sub

        End If


        For i_index_device = 0 To i_number_of_devices - 1

            i_me_error = meQueryInfoDevice(i_index_device, _
                                            i_vendor_id, _
                                            i_device_id, _
                                            i_serial_no, _
                                            i_bus_type, _
                                            i_bus_no, _
                                            i_dev_no, _
                                            i_func_no, _
                                            i_plugged)

            If (i_plugged <> ME_PLUGGED_IN) Then

                Continue For

            End If

            i_me_error = meQuerySubdeviceByType(i_index_device, _
                                                 0, _
                                                 ME_TYPE_AO, _
                                                 ME_SUBTYPE_STREAMING, _
                                                 giSubdeviceNumber)

            If (i_me_error = ME_ERRNO_SUCCESS) Then

                giDeviceNumber = i_index_device

                Exit For

            End If

        Next i_index_device


        If (giSubdeviceNumber = -1) Then

            MessageBox.Show("No AO-Streaming sub-device found in system")

            i_me_error = meClose(0)

            Close()

            Exit Sub

        End If

        cmdStart.Enabled = True
        cmdStop.Enabled = False

    End Sub


End Class