// ME5xxxPPDI.cpp : implementation file
//

#include "stdafx.h"
#include "Dlg_ME-5xxx.h"
#include "ME5xxxPPDI.h"

#define UNIT_HZ		1
#define UNIT_KHZ	1000
#define UNIT_MHZ	1000000

struct SSamplingRateEntry
{
	int	m_iUnit;

	int	m_iValue;
}
arrSamplingRateEntries[] = {	{UNIT_HZ, 1},
								{UNIT_HZ, 10},
								{UNIT_HZ, 100},
								{UNIT_KHZ, 1},
								{UNIT_KHZ, 10},
								{UNIT_KHZ, 100},
								{UNIT_MHZ, 1},
								{UNIT_MHZ, 2},
								{UNIT_MHZ, 3},
								{UNIT_MHZ, 6},
								{UNIT_MHZ, 11},
								{UNIT_MHZ, 22},
								{UNIT_MHZ, 33}	};

int arrFIFOIRQThresholds[] = {	1,
								5,
								10,
								50,
								100,
								500,
								1000,
								5000,
								10000,
								50000,
								100000	};
							


// CME5xxxPPDI dialog

IMPLEMENT_DYNAMIC(CME5xxxPPDI, CPropertyPage)

CME5xxxPPDI::CME5xxxPPDI()
	: CME5xxxPP(CME5xxxPPDI::IDD)
{

}

CME5xxxPPDI::~CME5xxxPPDI()
{
}

void CME5xxxPPDI::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CME5xxxPPDI, CPropertyPage)
	ON_BN_CLICKED(IDC_RESET, &CME5xxxPPDI::OnBnClickedReset)
	ON_BN_CLICKED(IDC_SINGLE_BUTTON_READ, &CME5xxxPPDI::OnSingleBnClickedRead)
	ON_BN_CLICKED(IDC_SINGLE_CHECK_HARDWARE_TRIGGER, &CME5xxxPPDI::OnSingleBnClickedCheckHardwareTrigger)
	ON_BN_CLICKED(IDC_STREAMING_START_CHECK_HARDWARE_TRIGGER, &CME5xxxPPDI::OnStreamingStartBnClickedCheckHardwareTrigger)
	ON_BN_CLICKED(IDC_STREAMING_BUTTON_START, &CME5xxxPPDI::OnStreamingBnClickedButtonStart)
	ON_BN_CLICKED(IDC_STREAMING_BUTTON_FILE_BROWSE, &CME5xxxPPDI::OnStreamingBnClickedButtonFileBrowse)
	ON_BN_CLICKED(IDC_STREAMING_CHECK_INTERNAL_COUNTER, &CME5xxxPPDI::OnStreamingBnClickedCheckInternalCounter)
	ON_BN_CLICKED(IDC_STREAMING_STOP_CHECK_STOP_AFTER, &CME5xxxPPDI::OnStreamingStopBnClickedCheckStopAfter)
	ON_BN_CLICKED(IDC_STREAMING_BUTTON_STOP, &CME5xxxPPDI::OnStreamingBnClickedButtonStop)
	ON_BN_CLICKED(IDC_STREAMING_STOP_CHECK_HARDWARE_TRIGGER, &CME5xxxPPDI::OnStreamingStopBnClickedCheckHardwareTrigger)
END_MESSAGE_MAP()


// CME5xxxPPDI message handlers

BOOL CME5xxxPPDI::OnInitDialog()
{
	CME5xxxPP::OnInitDialog();

	// TODO:  Add extra initialization here

	CheckDlgButton(IDC_SINGLE_CHECK_HARDWARE_TRIGGER, BST_UNCHECKED);

	OnSingleBnClickedCheckHardwareTrigger();

	SetDlgItemInt(IDC_SINGLE_EDIT_TIMEOUT, 1000);

	for(int index_sample_rate = 0; index_sample_rate < sizeof(arrSamplingRateEntries) / sizeof( arrSamplingRateEntries[0] ); index_sample_rate++)
	{
		CString cs_entry;

		cs_entry.Format(_T("%3d "), arrSamplingRateEntries[index_sample_rate].m_iValue);

		if(arrSamplingRateEntries[index_sample_rate].m_iUnit == UNIT_HZ)
		{
			cs_entry+= _T("Hz");
		}
		else if(arrSamplingRateEntries[index_sample_rate].m_iUnit == UNIT_KHZ)
		{
			cs_entry+= _T("kHz");
		}
		else // if(arrSamplingRateEntries[index_sample_rate].m_iUnit == UNIT_MHZ)
		{
			cs_entry+= _T("MHz");
		}

		( (CComboBox*)( GetDlgItem(IDC_STREAMING_COMBO_SAMPLING_RATE) ) )->AddString(cs_entry);
	}

	( (CComboBox*)( GetDlgItem(IDC_STREAMING_COMBO_SAMPLING_RATE) ) )->SetCurSel(3);	// 1 kHz

	for(int index_fifo_irq_threshold = 0; index_fifo_irq_threshold < sizeof(arrFIFOIRQThresholds) / sizeof( arrFIFOIRQThresholds[0] ); index_fifo_irq_threshold++)
	{
		CString cs_entry;

		cs_entry.Format( _T("%6d"), arrFIFOIRQThresholds[index_fifo_irq_threshold] );

		( (CComboBox*)( GetDlgItem(IDC_STREAMING_COMBO_FIFO_IRQ_THRESHOLD) ) )->AddString(cs_entry);
	}

	( (CComboBox*)( GetDlgItem(IDC_STREAMING_COMBO_FIFO_IRQ_THRESHOLD) ) )->SetCurSel(4);	// 100

	CheckDlgButton(IDC_STREAMING_CHECK_INTERNAL_COUNTER, BST_UNCHECKED);

	CheckDlgButton(IDC_STREAMING_START_CHECK_HARDWARE_TRIGGER, BST_UNCHECKED);

	OnStreamingStartBnClickedCheckHardwareTrigger();

	SetDlgItemInt(IDC_STREAMING_START_EDIT_TIMEOUT, 1000);

	CheckDlgButton(IDC_STREAMING_STOP_CHECK_HARDWARE_TRIGGER, BST_UNCHECKED);

	OnStreamingStopBnClickedCheckHardwareTrigger();

	CheckDlgButton(IDC_STREAMING_STOP_CHECK_STOP_AFTER, BST_UNCHECKED);

	OnStreamingStopBnClickedCheckStopAfter();

	SetDlgItemInt(IDC_STREAMING_STOP_EDIT_AFTER_VALUES, 1000);

	meIOStreamSetCallbacks(m_iDeviceIndex, m_iSubdeviceIndex, 
									StreamingStartCallback, this, 
										StreamingNewValuesCallback, this, 
												StreamingEndCallback, this, 
													ME_IO_STREAM_SET_CALLBACKS_NO_FLAGS); 

	m_pDataFile = NULL;

	m_piDataBuffer = new int[0x10000];

	m_iDataBufferSize = 0x10000;

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CME5xxxPPDI::OnBnClickedReset()
{
	// TODO: Add your control notification handler code here

	int i_me_error = meIOResetSubdevice(m_iDeviceIndex, m_iSubdeviceIndex, ME_IO_RESET_SUBDEVICE_NO_FLAGS);
}

void CME5xxxPPDI::OnSingleBnClickedRead()
{
	// TODO: Add your control notification handler code here

	int i_trigger_type;

	int i_trigger_edge;

	int i_timeout;

	if( IsDlgButtonChecked(IDC_SINGLE_CHECK_HARDWARE_TRIGGER) == 0)
	{
		i_trigger_type = ME_TRIG_TYPE_SW;

		i_trigger_edge = ME_VALUE_NOT_USED;

		i_timeout = 0x00000000;
	}
	else
	{
		i_trigger_type = ME_TRIG_TYPE_EXT_DIGITAL;

		i_trigger_edge = 0x00000000;

		int i_mask = 0x00000001;

		for(int index_bit = 0; index_bit < 8; index_bit++)
		{
			if( IsDlgButtonChecked(IDC_SINGLE_CHECK_FALLING_EDGE_0 + index_bit) != 0 )
			{
				i_trigger_edge|= i_mask;
			}

			i_mask<<= 1;
		}
	
		i_mask = 0x00010000;

		for(int index_bit = 0; index_bit < 8; index_bit++)
		{
			if( IsDlgButtonChecked(IDC_SINGLE_CHECK_RISING_EDGE_0 + index_bit) != 0 )
			{
				i_trigger_edge|= i_mask;
			}

			i_mask<<= 1;
		}

		i_timeout = (int)GetDlgItemInt(IDC_SINGLE_EDIT_TIMEOUT);
	}

	if( IsDlgButtonChecked(IDC_SINGLE_CHECK_TRIGGER_A_FALLING_EDGE) != 0 )
	{
		i_trigger_edge|= 0x00008000;
	}

	if( IsDlgButtonChecked(IDC_SINGLE_CHECK_TRIGGER_A_RISING_EDGE) != 0 )
	{
		i_trigger_edge|= 0x80000000;
	}

	int i_me_error = meIOSingleConfig(	m_iDeviceIndex,						// Device index
										m_iSubdeviceIndex,					// Subdevcie index
										0,									// Channel
										ME_SINGLE_CONFIG_DIO_INPUT,			// Single config
										ME_VALUE_NOT_USED,					// Reference 
										ME_TRIG_CHAN_DEFAULT,				// Trigger channel
										i_trigger_type,						// Trigger type
										i_trigger_edge,						// Trigger edge
										ME_IO_SINGLE_CONFIG_DIO_WORD	);	// Flags

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		SetDlgItemText( IDC_SINGLE_VALUE, _T("????") );

		return;
	}

	meIOSingle_t io_single[1];

	io_single[0].iDevice = m_iDeviceIndex;

	io_single[0].iSubdevice = m_iSubdeviceIndex;
	io_single[0].iChannel	= 0;
	io_single[0].iDir		= ME_DIR_INPUT;
	io_single[0].iValue		= 0;
	io_single[0].iTimeOut	= i_timeout;							
	io_single[0].iFlags		= ME_IO_SINGLE_TYPE_DIO_WORD;
	
	i_me_error = meIOSingle(&io_single[0],				// Output list 
							1,							// Number of elements in the above list 
							ME_IO_SINGLE_NO_FLAGS	);	// Flags

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		SetDlgItemText( IDC_SINGLE_VALUE, _T("????") );

		return;
	}

	TCHAR sz_buffer[64];

	_stprintf_s(&sz_buffer[0], 64, _T("0x%04X"), (unsigned short)(io_single[0].iValue & 0x0000FFFF) );

	SetDlgItemText( IDC_SINGLE_VALUE, &sz_buffer[0] );
}

void CME5xxxPPDI::OnSingleBnClickedCheckHardwareTrigger()
{
	// TODO: Add your control notification handler code here

	if( IsDlgButtonChecked(IDC_SINGLE_CHECK_HARDWARE_TRIGGER) == 0)
	{
		GetDlgItem(IDC_SINGLE_TEXT_PORT_A)->EnableWindow(FALSE);

		GetDlgItem(IDC_SINGLE_TEXT_TRIGGER_A)->EnableWindow(FALSE);

		GetDlgItem(IDC_SINGLE_TEXT_EDGE_0)->EnableWindow(FALSE);

		GetDlgItem(IDC_SINGLE_TEXT_EDGE_4)->EnableWindow(FALSE);

		GetDlgItem(IDC_SINGLE_TEXT_FALLING_EDGE)->EnableWindow(FALSE);

		for(int index_bit = 0; index_bit < 8; index_bit++)
		{
			GetDlgItem(IDC_SINGLE_CHECK_FALLING_EDGE_0 + index_bit)->EnableWindow(FALSE);
		}

		GetDlgItem(IDC_SINGLE_TEXT_RISING_EDGE)->EnableWindow(FALSE);

		for(int index_bit = 0; index_bit < 8; index_bit++)
		{
			GetDlgItem(IDC_SINGLE_CHECK_RISING_EDGE_0 + index_bit)->EnableWindow(FALSE);
		}

		GetDlgItem(IDC_SINGLE_CHECK_TRIGGER_A_FALLING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_SINGLE_CHECK_TRIGGER_A_RISING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_SINGLE_TEXT_TIMEOUT)->EnableWindow(FALSE);

		GetDlgItem(IDC_SINGLE_EDIT_TIMEOUT)->EnableWindow(FALSE);

		GetDlgItem(IDC_SINGLE_TEXT_MS)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_SINGLE_TEXT_PORT_A)->EnableWindow(TRUE);

		GetDlgItem(IDC_SINGLE_TEXT_TRIGGER_A)->EnableWindow(TRUE);

		GetDlgItem(IDC_SINGLE_TEXT_EDGE_0)->EnableWindow(TRUE);

		GetDlgItem(IDC_SINGLE_TEXT_EDGE_4)->EnableWindow(TRUE);

		GetDlgItem(IDC_SINGLE_TEXT_FALLING_EDGE)->EnableWindow(TRUE);

		for(int index_bit = 0; index_bit < 8; index_bit++)
		{
			GetDlgItem(IDC_SINGLE_CHECK_FALLING_EDGE_0 + index_bit)->EnableWindow(TRUE);
		}

		GetDlgItem(IDC_SINGLE_TEXT_RISING_EDGE)->EnableWindow(TRUE);

		for(int index_bit = 0; index_bit < 8; index_bit++)
		{
			GetDlgItem(IDC_SINGLE_CHECK_RISING_EDGE_0 + index_bit)->EnableWindow(TRUE);
		}

		GetDlgItem(IDC_SINGLE_CHECK_TRIGGER_A_FALLING_EDGE)->EnableWindow(TRUE);

		GetDlgItem(IDC_SINGLE_CHECK_TRIGGER_A_RISING_EDGE)->EnableWindow(TRUE);

		GetDlgItem(IDC_SINGLE_TEXT_TIMEOUT)->EnableWindow(TRUE);

		GetDlgItem(IDC_SINGLE_EDIT_TIMEOUT)->EnableWindow(TRUE);

		GetDlgItem(IDC_SINGLE_TEXT_MS)->EnableWindow(TRUE);
	}
}

void CME5xxxPPDI::OnStreamingBnClickedButtonFileBrowse()
{
	// TODO: Add your control notification handler code here

	CFileDialog dlg(FALSE, L".m5d", NULL, OFN_OVERWRITEPROMPT|OFN_PATHMUSTEXIST, L"m5d-Dateien (*.m5d)|*.m5d||");

	if(dlg.DoModal() == IDOK)
	{
		GetDlgItem(IDC_STREAMING_EDIT_FILE_NAME)->SetWindowText( dlg.GetPathName() );
	}
}

void CME5xxxPPDI::OnStreamingStartBnClickedCheckHardwareTrigger()
{
	// TODO: Add your control notification handler code here

	if( IsDlgButtonChecked(IDC_STREAMING_START_CHECK_HARDWARE_TRIGGER) == 0)
	{
		GetDlgItem(IDC_STREAMING_START_TEXT_PORT_A)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_TRIGGER_A)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_EDGE_0)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_EDGE_4)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_EDGE_8)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_EDGE_12)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_FALLING_EDGE)->EnableWindow(FALSE);

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			GetDlgItem(IDC_STREAMING_START_CHECK_FALLING_EDGE_0 + index_bit)->EnableWindow(FALSE);
		}

		GetDlgItem(IDC_STREAMING_START_CHECK_TRIGGER_A_FALLING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_RISING_EDGE)->EnableWindow(FALSE);

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			GetDlgItem(IDC_STREAMING_START_CHECK_RISING_EDGE_0 + index_bit)->EnableWindow(FALSE);
		}

		GetDlgItem(IDC_STREAMING_START_CHECK_TRIGGER_A_RISING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_CHECK_ACQUIRE_ONE_VALUE_PER_TRIGGER)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_TIMEOUT)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_EDIT_TIMEOUT)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_MS)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_STREAMING_START_TEXT_PORT_A)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_TEXT_TRIGGER_A)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_TEXT_EDGE_0)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_TEXT_EDGE_4)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_TEXT_EDGE_8)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_TEXT_EDGE_12)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_TEXT_FALLING_EDGE)->EnableWindow(TRUE);

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			GetDlgItem(IDC_STREAMING_START_CHECK_FALLING_EDGE_0 + index_bit)->EnableWindow(TRUE);
		}

		GetDlgItem(IDC_STREAMING_START_CHECK_TRIGGER_A_FALLING_EDGE)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_TEXT_RISING_EDGE)->EnableWindow(TRUE);

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			GetDlgItem(IDC_STREAMING_START_CHECK_RISING_EDGE_0 + index_bit)->EnableWindow(TRUE);
		}

		GetDlgItem(IDC_STREAMING_START_CHECK_TRIGGER_A_RISING_EDGE)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_CHECK_ACQUIRE_ONE_VALUE_PER_TRIGGER)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_TEXT_TIMEOUT)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_EDIT_TIMEOUT)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_START_TEXT_MS)->EnableWindow(TRUE);
	}
}

void CME5xxxPPDI::OnStreamingBnClickedButtonStart()
{
	// TODO: Add your control notification handler code here

	TCHAR sz_file_name[_MAX_PATH];

	GetDlgItemText(IDC_STREAMING_EDIT_FILE_NAME, &sz_file_name[0], _MAX_PATH);

	m_pDataFile = NULL;

	m_iDataFileSize = 0;

	if( (_tfopen_s( &m_pDataFile, &sz_file_name[0], _T("wb") ) != 0)||(m_pDataFile == NULL) )
	{
		_TCHAR sz_message[_MAX_PATH + 64];

		_stprintf_s( &sz_message[0], _MAX_PATH + 64, _T("Cannot open or create file: <%s>"), &sz_file_name[0] );

		AfxMessageBox(&sz_message[0], MB_OK | MB_ICONEXCLAMATION);

		return;
	}

	int i_index_sample_rate = ( (CComboBox*)( GetDlgItem(IDC_STREAMING_COMBO_SAMPLING_RATE) ) )->GetCurSel();

	double d_freq = (double)arrSamplingRateEntries[i_index_sample_rate].m_iValue;

	if(arrSamplingRateEntries[i_index_sample_rate].m_iUnit == UNIT_KHZ)
	{
		d_freq*= 1000.0;
	}
	else if(arrSamplingRateEntries[i_index_sample_rate].m_iUnit == UNIT_MHZ)
	{
		d_freq*= 1000000.0;
	}

	int i_conv_ticks_low = 0;
	int i_conv_ticks_high = 0;

	int i_me_error = meIOStreamFrequencyToTicks(m_iDeviceIndex,						// Device index
												m_iSubdeviceIndex,					// Subdevice indexe, 
												ME_TIMER_CONV_START,				// Timer used 
												&d_freq,							// Required frequency Hz, Achieved frequency returned here	 
												&i_conv_ticks_low,					// Lower 32 bits of the corresponding tick value returned here
												&i_conv_ticks_high,					// Upper 32 bits of the corresponding tick value returned here
												ME_IO_FREQUENCY_TO_TICKS_NO_FLAGS); // No flags

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
	}

	int b_internal_counter = ( IsDlgButtonChecked(IDC_STREAMING_CHECK_INTERNAL_COUNTER) == 0 ) ? 0 : 1;

	meIOStreamConfig_t arr_stream_config[1];

	memset( &arr_stream_config[0], 0, sizeof(meIOStreamConfig_t) );

	arr_stream_config[0].iChannel = 0;

	arr_stream_config[0].iStreamConfig = ME_VALUE_NOT_USED;
	arr_stream_config[0].iRef = ME_VALUE_NOT_USED;
	arr_stream_config[0].iFlags = ME_IO_STREAM_CONFIG_TYPE_NO_FLAGS;

	meIOStreamTrigger_t stream_trigger;

	memset( &stream_trigger, 0, sizeof(meIOStreamTrigger_t) );

	int b_value_per_trigger = 0;

	if( ( IsDlgButtonChecked(IDC_STREAMING_START_CHECK_HARDWARE_TRIGGER) == 0)||( b_internal_counter != 0) )
	{
		stream_trigger.iAcqStartTrigType = ME_TRIG_TYPE_SW;
	}
	else
	{
		stream_trigger.iAcqStartTrigType = ME_TRIG_TYPE_EXT_DIGITAL;
	
		stream_trigger.iAcqStartTrigEdge = 0x00000000;

		int i_mask = 0x00000001;

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			if( IsDlgButtonChecked(IDC_STREAMING_START_CHECK_FALLING_EDGE_0 + index_bit) != 0 )
			{
				stream_trigger.iAcqStartTrigEdge|= i_mask;
			}

			i_mask<<= 1;
		}
	
		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			if( IsDlgButtonChecked(IDC_STREAMING_START_CHECK_RISING_EDGE_0 + index_bit) != 0 )
			{
				stream_trigger.iAcqStartTrigEdge|= i_mask;
			}

			i_mask<<= 1;
		}

		stream_trigger.iAcqStartArgs[0] = 0x00000000;

		if( IsDlgButtonChecked(IDC_STREAMING_START_CHECK_TRIGGER_A_FALLING_EDGE) != 0 )
		{
			stream_trigger.iAcqStartArgs[0]|= 0x00000001;
		}

		if( IsDlgButtonChecked(IDC_STREAMING_START_CHECK_TRIGGER_A_RISING_EDGE) != 0 )
		{
			stream_trigger.iAcqStartArgs[0]|= 0x00010000;
		}

		if(IsDlgButtonChecked(IDC_STREAMING_CHECK_ACQUIRE_ONE_VALUE_PER_TRIGGER) != 0)
		{
			b_value_per_trigger = 1;
		}
	}
	
	stream_trigger.iAcqStartTrigChan = ME_TRIG_CHAN_DEFAULT;
	stream_trigger.iAcqStartTicksLow = 0;
	stream_trigger.iAcqStartTicksHigh = 0;

	stream_trigger.iScanStartTrigType = ME_TRIG_TYPE_FOLLOW;
	stream_trigger.iScanStartTicksLow = 0;
	stream_trigger.iScanStartTicksHigh = 0;

	//int iScanStartArgs[10];

	if(b_value_per_trigger == 0)
	{
		stream_trigger.iConvStartTrigType = ME_TRIG_TYPE_TIMER;

		stream_trigger.iConvStartTicksLow = i_conv_ticks_low;
		stream_trigger.iConvStartTicksHigh = i_conv_ticks_high;
	}
	else
	{
		stream_trigger.iConvStartTrigType = ME_TRIG_TYPE_EXT_DIGITAL;

		stream_trigger.iConvStartTicksLow = 0;
		stream_trigger.iConvStartTicksHigh = 0;
	}

	// int iConvStartArgs[10];
	// int iScanStopTrigType;
	// int iScanStopCount;
	// int iScanStopArgs[10];

	int b_hardware_trigger = 0;

	int b_count = 0;

	if(IsDlgButtonChecked(IDC_STREAMING_CHECK_INTERNAL_COUNTER) == 0)
	{
		if(IsDlgButtonChecked(IDC_STREAMING_STOP_CHECK_HARDWARE_TRIGGER) != 0)
		{
			stream_trigger.iAcqStopArgs[0] = 0x00000000;

			int i_mask = 0x00000001;

			for(int index_bit = 0; index_bit < 16; index_bit++)
			{
				if( IsDlgButtonChecked(IDC_STREAMING_STOP_CHECK_FALLING_EDGE_0 + index_bit) != 0 )
				{
					stream_trigger.iAcqStopArgs[0]|= i_mask;
				}

				i_mask<<= 1;
			}
		
			for(int index_bit = 0; index_bit < 16; index_bit++)
			{
				if( IsDlgButtonChecked(IDC_STREAMING_STOP_CHECK_RISING_EDGE_0 + index_bit) != 0 )
				{
					stream_trigger.iAcqStopArgs[0]|= i_mask;
				}

				i_mask<<= 1;
			}

			stream_trigger.iAcqStopArgs[1] = 0x00000000;

			if( IsDlgButtonChecked(IDC_STREAMING_STOP_CHECK_TRIGGER_A_FALLING_EDGE) != 0 )
			{
				stream_trigger.iAcqStopArgs[1]|= 0x00000001;
			}

			if( IsDlgButtonChecked(IDC_STREAMING_STOP_CHECK_TRIGGER_A_RISING_EDGE) != 0 )
			{
				stream_trigger.iAcqStopArgs[1]|= 0x00010000;
			}

			b_hardware_trigger = 1;
		}
	}


	if(IsDlgButtonChecked(IDC_STREAMING_STOP_CHECK_STOP_AFTER) != 0)
	{
		stream_trigger.iAcqStopCount = GetDlgItemInt(IDC_STREAMING_STOP_EDIT_AFTER_VALUES);

		m_iAcquisitionSize = stream_trigger.iAcqStopCount;

		b_count = 1;
	}
	else
	{
		m_iAcquisitionSize = 0;
	}

	if( (b_hardware_trigger == 1)&&(b_count == 1) )
	{
		stream_trigger.iAcqStopTrigType = ME_TRIG_TYPE_EXT_DIGITAL_OR_COUNT;
	}
	else if(b_hardware_trigger == 1)
	{
		stream_trigger.iAcqStopTrigType = ME_TRIG_TYPE_EXT_DIGITAL;
	}
	else if(b_count == 1)
	{
		stream_trigger.iAcqStopTrigType = ME_TRIG_TYPE_COUNT;
	}
	else
	{
		stream_trigger.iAcqStopTrigType = ME_TRIG_TYPE_NONE;
	}

	int i_threshold_index = ( (CComboBox*)GetDlgItem(IDC_STREAMING_COMBO_FIFO_IRQ_THRESHOLD) )->GetCurSel();

	int i_threshold = arrFIFOIRQThresholds[i_threshold_index];

	stream_trigger.iFlags = ME_IO_STREAM_TRIGGER_TYPE_NO_FLAGS;

	int i_stream_config_flags = (b_internal_counter == 0) ? ME_IO_STREAM_CONFIG_NO_FLAGS : ME_IO_STREAM_CONFIG_INTERNAL_COUNTER;

	i_me_error = meIOStreamConfig(	m_iDeviceIndex,				// Device index
									m_iSubdeviceIndex,			// Subdevice index, 
 									&arr_stream_config[0],		// Pointer to an array of meIOStreamConfig_t structures
									1,							// Number of elements in the stream config array above
									&stream_trigger,			// Pointer to an meIOStreamTrigger_t structure
									i_threshold,				// FIFO IRQ threshold
									i_stream_config_flags	);	// 0x8000000 --> Temporary flag for Tests
	
	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		return;
	}

	int i_time_out_ms = 0;

	if( ( IsDlgButtonChecked(IDC_STREAMING_START_CHECK_HARDWARE_TRIGGER) != 0)&&( b_internal_counter == 0) )
	{
		i_time_out_ms = GetDlgItemInt(IDC_STREAMING_START_EDIT_TIMEOUT);
	}
	
	meIOStreamStart_t arr_stream_start[1];

	arr_stream_start[0].iDevice = m_iDeviceIndex;
	arr_stream_start[0].iSubdevice = m_iSubdeviceIndex;
	arr_stream_start[0].iStartMode = ME_START_MODE_BLOCKING;
	arr_stream_start[0].iTimeOut = i_time_out_ms;
	arr_stream_start[0].iFlags = ME_IO_STREAM_START_TYPE_NO_FLAGS;
	arr_stream_start[0].iErrno = 0;
	
	i_me_error = meIOStreamStart(	&arr_stream_start[0],			// Pointer to an array of meIOStreamStart_t structures 
									1,								// Number of elements in the stream start array above
									ME_IO_STREAM_START_NO_FLAGS	);	// No flags

	if( (i_me_error != ME_ERRNO_SUCCESS)&&(m_pDataFile != NULL) )
	{
		fclose(m_pDataFile);

		m_pDataFile = NULL;
	}
}

int __stdcall CME5xxxPPDI :: StreamingStartCallback(int iDevice, int iSubdevice, int iCount, void *pvContext, int iErrorCode)
{
	if(iErrorCode != ME_ERRNO_SUCCESS)
	{
		return iErrorCode;
	}
	
	CME5xxxPPDI* p_me5xxx_pp_di = (CME5xxxPPDI*)pvContext;

	p_me5xxx_pp_di->SetDlgItemText( IDC_TEXT_ACQUISITION_STATUS, _T("Aquisition running") );
	
	return ME_ERRNO_SUCCESS;
}

int __stdcall CME5xxxPPDI :: StreamingNewValuesCallback(int iDevice, int iSubdevice, int iCount, void *pvContext, int iErrorCode)
{
	if(iErrorCode != ME_ERRNO_SUCCESS)
	{
		return iErrorCode;
	}
	
	CME5xxxPPDI* p_me5xxx_pp_di = (CME5xxxPPDI*)pvContext;

	if(p_me5xxx_pp_di->m_iDataBufferSize < iCount)
	{
		if(p_me5xxx_pp_di->m_piDataBuffer != NULL)
		{
			delete p_me5xxx_pp_di->m_piDataBuffer;
		}

		p_me5xxx_pp_di->m_piDataBuffer = new int[iCount * 2];

		p_me5xxx_pp_di->m_iDataBufferSize = iCount * 2;
	}

	int i_read_size = iCount;
	
	int i_me_error = meIOStreamRead(p_me5xxx_pp_di->m_iDeviceIndex, p_me5xxx_pp_di->m_iSubdeviceIndex, ME_READ_MODE_NONBLOCKING, &p_me5xxx_pp_di->m_piDataBuffer[0], &i_read_size, ME_IO_STREAM_READ_NO_FLAGS);
	
	int b_terminate = 0;

	if( (i_me_error == ME_ERRNO_SUCCESS)&&(i_read_size > 0) )
	{
		fwrite(&p_me5xxx_pp_di->m_piDataBuffer[0], sizeof(int), i_read_size, p_me5xxx_pp_di->m_pDataFile);

		p_me5xxx_pp_di->m_iDataFileSize+= i_read_size;

		if(p_me5xxx_pp_di->m_iAcquisitionSize > 0)
		{
			p_me5xxx_pp_di->m_iAcquisitionSize-= i_read_size;

			if(p_me5xxx_pp_di->m_iAcquisitionSize <= 0)
			{
				b_terminate = 1;
			}
		}
	}
	
	TCHAR sz_buffer[256];

	_stprintf_s(&sz_buffer[0], 64, _T("Aquisition running - %d value written to file"), p_me5xxx_pp_di->m_iDataFileSize);

	p_me5xxx_pp_di->SetDlgItemText( IDC_TEXT_ACQUISITION_STATUS, &sz_buffer[0] );

	if(b_terminate != 0)
	{
		return -1;
	}

	return ME_ERRNO_SUCCESS;
}

int __stdcall CME5xxxPPDI :: StreamingEndCallback(int iDevice, int iSubdevice, int iCount, void *pvContext, int iErrorCode)
{
	CME5xxxPPDI* p_me5xxx_pp_di = (CME5xxxPPDI*)pvContext;

	while(true)
	{
		int i_read_size = p_me5xxx_pp_di->m_iDataBufferSize;
		
		int i_me_error = meIOStreamRead(p_me5xxx_pp_di->m_iDeviceIndex, p_me5xxx_pp_di->m_iSubdeviceIndex, ME_READ_MODE_NONBLOCKING, &p_me5xxx_pp_di->m_piDataBuffer[0], &i_read_size, ME_IO_STREAM_READ_NO_FLAGS);
		
		if( (i_me_error == ME_ERRNO_SUCCESS)&&(i_read_size > 0) )
		{
			fwrite(&p_me5xxx_pp_di->m_piDataBuffer[0], sizeof(int), i_read_size, p_me5xxx_pp_di->m_pDataFile);

			p_me5xxx_pp_di->m_iDataFileSize+= i_read_size;
		}

		if(i_read_size < p_me5xxx_pp_di->m_iDataBufferSize)
		{
			break;
		}
	}
	
	if(p_me5xxx_pp_di->m_pDataFile != NULL)
	{
		fclose(p_me5xxx_pp_di->m_pDataFile);

		p_me5xxx_pp_di->m_pDataFile = NULL;
	}

//	TCHAR sz_buffer[256];

//	_stprintf_s(&sz_buffer[0], 64, _T("Aquisition terminated - %d values written to file"), p_me5xxx_pp_di->m_iDataFileSize);

//	p_me5xxx_pp_di->SetDlgItemText( IDC_TEXT_ACQUISITION_STATUS, &sz_buffer[0] );

	return iErrorCode;
}

void CME5xxxPPDI::OnStreamingBnClickedCheckInternalCounter()
{
	// TODO: Add your control notification handler code here

	if( IsDlgButtonChecked(IDC_STREAMING_CHECK_INTERNAL_COUNTER) == 0 )
	{
		GetDlgItem(IDC_STREAMING_START_CHECK_HARDWARE_TRIGGER)->EnableWindow(TRUE);

		OnStreamingStartBnClickedCheckHardwareTrigger();

		GetDlgItem(IDC_STREAMING_STOP_CHECK_HARDWARE_TRIGGER)->EnableWindow(TRUE);

		OnStreamingStopBnClickedCheckHardwareTrigger();
	}
	else
	{
		GetDlgItem(IDC_STREAMING_START_CHECK_HARDWARE_TRIGGER)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_PORT_A)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_TRIGGER_A)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_EDGE_0)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_EDGE_4)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_EDGE_8)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_EDGE_12)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_FALLING_EDGE)->EnableWindow(FALSE);

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			GetDlgItem(IDC_STREAMING_START_CHECK_FALLING_EDGE_0 + index_bit)->EnableWindow(FALSE);
		}

		GetDlgItem(IDC_STREAMING_START_TEXT_RISING_EDGE)->EnableWindow(FALSE);

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			GetDlgItem(IDC_STREAMING_START_CHECK_RISING_EDGE_0 + index_bit)->EnableWindow(FALSE);
		}

		GetDlgItem(IDC_STREAMING_START_TEXT_TIMEOUT)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_EDIT_TIMEOUT)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_MS)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_TEXT_TRIGGER_A)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_CHECK_TRIGGER_A_FALLING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_START_CHECK_TRIGGER_A_RISING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_CHECK_HARDWARE_TRIGGER)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_PORT_A)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_TRIGGER_A)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_0)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_4)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_8)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_12)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_FALLING_EDGE)->EnableWindow(FALSE);

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			GetDlgItem(IDC_STREAMING_STOP_CHECK_FALLING_EDGE_0 + index_bit)->EnableWindow(FALSE);
		}

		GetDlgItem(IDC_STREAMING_STOP_TEXT_RISING_EDGE)->EnableWindow(FALSE);

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			GetDlgItem(IDC_STREAMING_STOP_CHECK_RISING_EDGE_0 + index_bit)->EnableWindow(FALSE);
		}

		GetDlgItem(IDC_STREAMING_STOP_TEXT_TRIGGER_A)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_CHECK_TRIGGER_A_FALLING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_CHECK_TRIGGER_A_RISING_EDGE)->EnableWindow(FALSE);
	}
}

void CME5xxxPPDI::OnStreamingStopBnClickedCheckHardwareTrigger()
{
	// TODO: Add your control notification handler code here

	if( IsDlgButtonChecked(IDC_STREAMING_STOP_CHECK_HARDWARE_TRIGGER) == 0)
	{
		GetDlgItem(IDC_STREAMING_STOP_TEXT_PORT_A)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_TRIGGER_A)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_0)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_4)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_8)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_12)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_FALLING_EDGE)->EnableWindow(FALSE);

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			GetDlgItem(IDC_STREAMING_STOP_CHECK_FALLING_EDGE_0 + index_bit)->EnableWindow(FALSE);
		}

		GetDlgItem(IDC_STREAMING_STOP_TEXT_RISING_EDGE)->EnableWindow(FALSE);

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			GetDlgItem(IDC_STREAMING_STOP_CHECK_RISING_EDGE_0 + index_bit)->EnableWindow(FALSE);
		}

		GetDlgItem(IDC_STREAMING_STOP_TEXT_TRIGGER_A)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_CHECK_TRIGGER_A_FALLING_EDGE)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_CHECK_TRIGGER_A_RISING_EDGE)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_STREAMING_STOP_TEXT_PORT_A)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_TRIGGER_A)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_0)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_4)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_8)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_EDGE_12)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_FALLING_EDGE)->EnableWindow(TRUE);

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			GetDlgItem(IDC_STREAMING_STOP_CHECK_FALLING_EDGE_0 + index_bit)->EnableWindow(TRUE);
		}

		GetDlgItem(IDC_STREAMING_STOP_TEXT_RISING_EDGE)->EnableWindow(TRUE);

		for(int index_bit = 0; index_bit < 16; index_bit++)
		{
			GetDlgItem(IDC_STREAMING_STOP_CHECK_RISING_EDGE_0 + index_bit)->EnableWindow(TRUE);
		}

		GetDlgItem(IDC_STREAMING_STOP_TEXT_TRIGGER_A)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_CHECK_TRIGGER_A_FALLING_EDGE)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_CHECK_TRIGGER_A_RISING_EDGE)->EnableWindow(TRUE);
	}
}

void CME5xxxPPDI::OnStreamingStopBnClickedCheckStopAfter()
{
	// TODO: Add your control notification handler code here

	if( IsDlgButtonChecked(IDC_STREAMING_STOP_CHECK_STOP_AFTER) == 0)
	{
		GetDlgItem(IDC_STREAMING_STOP_EDIT_AFTER_VALUES)->EnableWindow(FALSE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_AFTER_VALUES)->EnableWindow(FALSE);
	}
	else
	{
		GetDlgItem(IDC_STREAMING_STOP_EDIT_AFTER_VALUES)->EnableWindow(TRUE);

		GetDlgItem(IDC_STREAMING_STOP_TEXT_AFTER_VALUES)->EnableWindow(TRUE);
	}
}

void CME5xxxPPDI::OnStreamingBnClickedButtonStop()
{
	// TODO: Add your control notification handler code here

	meIOStreamStop_t arr_stream_stop[1];

	arr_stream_stop[0].iDevice = m_iDeviceIndex;
	arr_stream_stop[0].iSubdevice = m_iSubdeviceIndex;
	arr_stream_stop[0].iStopMode = ME_STOP_MODE_IMMEDIATE;
	arr_stream_stop[0].iFlags = ME_IO_STREAM_STOP_TYPE_NO_FLAGS;
	arr_stream_stop[0].iErrno = 0;

	int i_me_error = meIOStreamStop(&arr_stream_stop[0],			// Pointer to an array of meIOStreamStop_t structures  
									1,								// Number of elements in the stream stop array above
									ME_IO_STREAM_STOP_NO_FLAGS);	// No flags
}


