// ME5xxxPPFI.cpp : implementation file
//

#include "stdafx.h"
#include "Dlg_ME-5xxx.h"
#include "ME5xxxPPFI.h"


// CME5xxxPPFI dialog

IMPLEMENT_DYNAMIC(CME5xxxPPFI, CPropertyPage)

CME5xxxPPFI::CME5xxxPPFI()
	: CME5xxxPP(CME5xxxPPFI::IDD)
{

}

CME5xxxPPFI::~CME5xxxPPFI()
{
}

void CME5xxxPPFI::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CME5xxxPPFI, CPropertyPage)
	ON_BN_CLICKED(IDC_RESET, &CME5xxxPPFI::OnBnClickedReset)
	ON_BN_CLICKED(IDC_READ_1, &CME5xxxPPFI::OnBnClickedRead1)
	ON_BN_CLICKED(IDC_READ_2, &CME5xxxPPFI::OnBnClickedRead2)
	ON_BN_CLICKED(IDC_READ_3, &CME5xxxPPFI::OnBnClickedRead3)
	ON_BN_CLICKED(IDC_READ_4, &CME5xxxPPFI::OnBnClickedRead4)
END_MESSAGE_MAP()


// CME5xxxPPFI message handlers

void CME5xxxPPFI::OnBnClickedReset()
{
	// TODO: Add your control notification handler code here

	int i_me_error = meIOResetSubdevice(m_iDeviceIndex, m_iSubdeviceIndex, ME_IO_RESET_SUBDEVICE_NO_FLAGS);

	for(int index_channel = 0; index_channel < 4; index_channel++)
	{
		SetDlgItemText( IDC_TOTAL_SEC_1 + index_channel, _T("????") );
		
		SetDlgItemText( IDC_PHASE_1_SEC_1 + index_channel, _T("????") );
		
		SetDlgItemText( IDC_FREQ_HZ_1 + index_channel, _T("????") );
		
		SetDlgItemText( IDC_DUTY_CYCLE_1 + index_channel, _T("????") );
	}
}

void CME5xxxPPFI::OnBnClickedRead1()
{
	// TODO: Add your control notification handler code here

	Read(0);
}

void CME5xxxPPFI::OnBnClickedRead2()
{
	// TODO: Add your control notification handler code here

	Read(1);
}

void CME5xxxPPFI::OnBnClickedRead3()
{
	// TODO: Add your control notification handler code here

	Read(2);
}

void CME5xxxPPFI::OnBnClickedRead4()
{
	// TODO: Add your control notification handler code here

	Read(3);
}

void CME5xxxPPFI :: Read(int iChannelIndex)
{
	int i_timeout = GetDlgItemInt(IDC_TIMEOUT_MS_1 + iChannelIndex);

	meIOSingle_t io_single[1];

	io_single[0].iDevice = m_iDeviceIndex;

	io_single[0].iSubdevice = m_iSubdeviceIndex;
	io_single[0].iChannel	= iChannelIndex;
	io_single[0].iDir		= ME_DIR_INPUT;
	io_single[0].iValue		= 0;
	io_single[0].iTimeOut	= i_timeout;		
	io_single[0].iFlags		= ME_IO_SINGLE_TYPE_FIO_TICKS_TOTAL;
	
	int i_me_error = meIOSingle(&io_single[0],				// Output list 
								1,							// Number of elements in the above list 
								ME_IO_SINGLE_NO_FLAGS	);	// Flags

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		SetDlgItemText( IDC_TOTAL_SEC_1 + iChannelIndex, _T("????") );
		
		SetDlgItemText( IDC_PHASE_1_SEC_1 + iChannelIndex, _T("????") );
		
		SetDlgItemText( IDC_FREQ_HZ_1 + iChannelIndex, _T("????") );
		
		SetDlgItemText( IDC_DUTY_CYCLE_1 + iChannelIndex, _T("????") );

		return;
	}

	double d_time_total;

	i_me_error = meIOSingleTicksToTime(	m_iDeviceIndex,							// Device
										m_iSubdeviceIndex,						// Sub-device
										ME_TIMER_FIO_TOTAL,						// iTimer
										io_single[0].iValue,					// Ticks low
										0,										// Ticks high
										&d_time_total,							// Corresponding time returned here
										ME_IO_SINGLE_TICKS_TO_TIME_NO_FLAGS	);	// flags
			
	io_single[0].iDevice = m_iDeviceIndex;

	io_single[0].iSubdevice = m_iSubdeviceIndex;
	io_single[0].iChannel	= iChannelIndex;
	io_single[0].iDir		= ME_DIR_INPUT;
	io_single[0].iValue		= 0;
	io_single[0].iTimeOut	= i_timeout;		
	io_single[0].iFlags		= ME_IO_SINGLE_TYPE_FIO_TICKS_FIRST_PHASE | ME_IO_SINGLE_TYPE_FI_LAST_VALUE;
	
	i_me_error = meIOSingle(&io_single[0],				// Output list 
							1,							// Number of elements in the above list 
							ME_IO_SINGLE_NO_FLAGS	);	// Flags


	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		// no reason why we should arrive here

		SetDlgItemText( IDC_TOTAL_SEC_1 + iChannelIndex, _T("????") );
		
		SetDlgItemText( IDC_PHASE_1_SEC_1 + iChannelIndex, _T("????") );
		
		SetDlgItemText( IDC_FREQ_HZ_1 + iChannelIndex, _T("????") );
		
		SetDlgItemText( IDC_DUTY_CYCLE_1 + iChannelIndex, _T("????") );

		return;
	}

	double d_time_first_phase;

	i_me_error = meIOSingleTicksToTime(	m_iDeviceIndex,							// Device
										m_iSubdeviceIndex,						// Sub-device
										ME_TIMER_FIO_FIRST_PHASE,				// iTimer
										io_single[0].iValue,					// Ticks low
										0,										// Ticks high
										&d_time_first_phase,					// Corresponding time returned here
										ME_IO_SINGLE_TICKS_TO_TIME_NO_FLAGS	);	// flags

	TCHAR sz_text[64];

	_stprintf_s(&sz_text[0], 64, _T("%f"), d_time_total);

	SetDlgItemText( IDC_TOTAL_SEC_1 + iChannelIndex, &sz_text[0] );

	_stprintf_s(&sz_text[0], 64, _T("%f"), d_time_first_phase);

	SetDlgItemText( IDC_PHASE_1_SEC_1 + iChannelIndex, &sz_text[0] );

	_stprintf_s(&sz_text[0], 64, _T("%f"), 1 / d_time_total);

	SetDlgItemText( IDC_FREQ_HZ_1 + iChannelIndex, &sz_text[0] );

	_stprintf_s(&sz_text[0], 64, _T("%f"), 100.0 * (d_time_total - d_time_first_phase) / d_time_total);

	SetDlgItemText( IDC_DUTY_CYCLE_1 + iChannelIndex, &sz_text[0] );
}

BOOL CME5xxxPPFI::OnInitDialog()
{
	CME5xxxPP::OnInitDialog();

	// TODO:  Add extra initialization here

	OnBnClickedReset();

	for(int index_channel = 0; index_channel < 4; index_channel++)
	{
		SetDlgItemInt(IDC_TIMEOUT_MS_1 + index_channel, 1000);
	}
	

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
