// TestDialog_StreamRead_CallbackDlg.h : header file
//

#pragma once

extern "C"
{
#include "..\\medriver.h"
}


#define MAX_STREAMING_SUBDEVICES	8

#define MAX_CHANNELS				4

// CTestDialog_StreamRead_CallbackDlg dialog
class CTestDialog_StreamRead_CallbackDlg : public CDialog
{
// Construction
public:
	CTestDialog_StreamRead_CallbackDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_TESTDIALOG_STREAMREAD_CALLBACK_DIALOG };

	protected:

	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	int m_iNumberOfAIStreamingSubdevices;
	
	struct SAIStreamingSubdevice
	{
		int m_iDeviceNumber;

		int m_iSubdeviceNumber;
	}
	m_arrAIStreamingSubdevices[MAX_STREAMING_SUBDEVICES];

	int m_iDevice;

	int m_iSubdevice;

	CRect m_rectPlot;

	struct SAIChannel
	{
		BOOL	m_bEnabled;
		
		int		m_iChannelIndex;

		int		m_iRangeIndex;
	}
	m_arrAIChannels[MAX_CHANNELS];

	COLORREF m_crChannelColors[MAX_CHANNELS];

	double	m_dWindowWidthSec;

	double	m_dWindowMinVolt;

	double	m_dWindowMaxVolt;

	double	m_dAchievedFreq;

	struct SAIChannelRange
	{
		double m_dMin;

		double m_dMax;

		int m_iMaxData;
	}
	m_arrAIChannelRange[MAX_CHANNELS];

	// Internal variables
	
	int m_iNumberOfChannels;
	
	meIOStreamConfig_t m_arrStreamConfig[MAX_CHANNELS];

	double m_dXIncrement;

	double m_dYConstant[MAX_CHANNELS];

	double m_dYFactor[MAX_CHANNELS];

	bool	m_bFirstDraw;
	
	double	m_dXLastPixel;
	
	int		m_iXLastPixel;
	
	int		m_iYLastPixel[MAX_CHANNELS];

private:

	void SetAIStreamingSubdevice(int iIndexSubdevice);

	static int _stdcall StreamReadNewValuesCallback(int iDevice, int iSubdevice, int iCount, void *pvContext, int iErrorCode);

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedStart();
public:
	afx_msg void OnBnClickedStop();
public:
	double m_dScanFrequency;
public:
	int m_iSampleCounter;
public:
	BOOL m_bEnableChannel1;
public:
	BOOL m_bEnableChannel2;
public:
	BOOL m_bEnableChannel3;
public:
	BOOL m_bEnableChannel4;
protected:
	virtual void OnCancel();
};
